import pywcs
import wcs_util

def check(header):
    
    wcs = pywcs.WCS(header)
    
    xproj = header['CTYPE1']
    yproj = header['CTYPE2']
    
    xproj = xproj[4:8]
    yproj = yproj[4:8]
    
    crpix1 = float(header['CRPIX1'])
    crpix2 = float(header['CRPIX2'])
    
    nx = int(header['NAXIS1'])
    ny = int(header['NAXIS1'])
    
    xcp = float(nx / 2)
    ycp = float(ny / 2)
    
    # Check that the two projections are equal
    
    if xproj<>yproj:
        raise Exception("x and y projections do not agree")
    
    # Remove any extra coordinates
    for key in ['CTYPE','CRPIX','CRVAL','CUNIT','CDELT','CROTA']:
        for coord in range(3,6):
            name = key + str(coord)
            if name in header:
                header.__delitem__(name)
    
    return header
